local list = require "./lua/list"
local setmetatable = setmetatable

module (...)

-- ----------------------------------------------------------------------------

function newUndoStack ()
	return UndoStack:new()
end

UndoStack = { }

function UndoStack:new ()
	obj = {	
		ustack = list.newRollingList (50),
		rstack = list.newRollingList (50),
	}
	setmetatable (obj, self)
	self.__index = self
	return obj
end

function UndoStack:logData (data)
	self.rstack:clear ()
	self.ustack:push (data)
end

function UndoStack:logUndo (data)
	self.ustack:push (data)
end

function UndoStack:logRedo (data)
	self.rstack:push (data)
end

function UndoStack:Undo ()
	if (self.ustack:empty() ) then
		return nil
	end
	return self.ustack:pop ()
end

function UndoStack:Redo ()
	if (self.rstack:empty() ) then
		return nil
	end
	return self.rstack:pop ()
end

function UndoStack:UndoAvailable ()
	if (self.ustack:empty() ) then
		return false
	end
	return true
end

function UndoStack:RedoAvailable ()
	if (self.rstack:empty() ) then
		return false
	end
	return true
end